Imports System.Configuration
Imports System.IO
Imports Facebook

Namespace FbAuthWpf.Common
	Public Class FbHelpers
		Public Shared Function GetLoginUrl() As String
			Dim client = New FacebookClient
			Dim fbLoginUri = client.GetLoginUrl(New With {Key .client_id = ConfigurationManager.AppSettings("fb_key"), Key .redirect_uri = "https://www.facebook.com/connect/login_success.html", Key .response_type = "code", Key .display = "popup", Key .scope = "email,publish_stream"})

			Return fbLoginUri.ToString
		End Function

		Public Shared Function GetAccessToken(ByVal oauthResult As FacebookOAuthResult) As String
			Dim client = New FacebookClient
            Dim result As Object = client.Get("/oauth/access_token", New With {Key .client_id = ConfigurationManager.AppSettings("fb_key"), Key .client_secret = ConfigurationManager.AppSettings("fb_secret"), Key .redirect_uri = "https://www.facebook.com/connect/login_success.html", Key .code = oauthResult.Code})

            Return result.access_token.ToString
		End Function

        Public Shared Function GetUser(ByVal token As String) As Object
            Dim client = New FacebookClient
            Dim user = client.Get("/me", New With {Key .fields = "first_name,last_name,email,picture,gender", Key .access_token = token})
            Return user
        End Function

		Public Shared Sub Post(ByVal token As String, ByVal status As String)
			Dim client = New FacebookClient(token)
			Dim result As Object = client.Post("/me/feed", New With {Key .message = status})
			Dim x = 0
		End Sub

		Public Shared Sub PostWithPhoto(ByVal token As String, ByVal status As String, ByVal photoPath As String)
			Dim client = New FacebookClient(token)
			Using stream = File.OpenRead(photoPath)
				Dim result As Object = client.Post("me/photos", New With {Key .message = status, Key .file = New FacebookMediaStream With {.ContentType = "image/jpg", .FileName = Path.GetFileName(photoPath)}.SetValue(stream)})
			End Using
		End Sub
	End Class
End Namespace
