Imports Facebook
Imports FbAuthWpf.Presenters

'Imports System
'Imports System.Windows
'Imports System.Windows.Controls
'Imports System.Windows.Navigation

Namespace FbAuthWpf
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class MainWindow
        Private ReadOnly _viewPresenter As MainWindowPresenter

		Public Sub New()
			InitializeComponent()
			AddHandler loginButton.Click, AddressOf loginButton_Click
			AddHandler logoutButton.Click, AddressOf logoutButton_Click
			AddHandler postButton.Click, AddressOf postButton_Click
			AddHandler browseButton.Click, AddressOf browseButton_Click
			AddHandler facebookBrowser.Navigated, AddressOf facebookBrowser_Navigated

			_viewPresenter = New MainWindowPresenter(Me)
			DataContext = _viewPresenter
		End Sub

		Public ReadOnly Property Browser As WebBrowser
			Get
				Return facebookBrowser
			End Get
		End Property

		Private Sub facebookBrowser_Navigated(ByVal sender As Object, ByVal e As NavigationEventArgs)
            Dim fb = New FacebookClient
            Dim oauthResult As FacebookOAuthResult = Nothing
			If Not fb.TryParseOAuthCallbackUrl(e.Uri, oauthResult) Then
				Exit Sub
			End If

			If oauthResult.IsSuccess Then
				_viewPresenter.LoginSucceeded(oauthResult)
			Else
				_viewPresenter.LoginFailed(oauthResult)
			End If
		End Sub

		Private Sub loginButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_viewPresenter.Login()
		End Sub

		Private Sub logoutButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_viewPresenter.Logout()
		End Sub

		Private Sub postButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_viewPresenter.PostUpdate()
		End Sub

		Private Sub browseButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_viewPresenter.BrowseForJpegFile()
		End Sub
	End Class
End Namespace
